diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-test-primary-cell-change.cc ns-3.36/src/lte/test/lte-test-primary-cell-change.cc
--- ns-3.35/src/lte/test/lte-test-primary-cell-change.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/lte/test/lte-test-primary-cell-change.cc	2022-04-30 18:23:58.062734600 -0700
@@ -0,0 +1,205 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Alexander Krotov
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alexander Krotov <krotov@iitp.ru>
+ *
+ */
+
+#include "lte-test-primary-cell-change.h"
+
+#include <ns3/boolean.h>
+#include <ns3/double.h>
+#include <ns3/integer.h>
+#include <ns3/log.h>
+#include <ns3/simulator.h>
+
+#include <ns3/internet-stack-helper.h>
+#include <ns3/ipv4-address-helper.h>
+#include <ns3/ipv4-interface-container.h>
+#include <ns3/friis-spectrum-propagation-loss.h>
+#include <ns3/ipv4-static-routing-helper.h>
+#include <ns3/lte-enb-net-device.h>
+#include <ns3/lte-helper.h>
+#include <ns3/lte-ue-net-device.h>
+#include <ns3/lte-ue-rrc.h>
+#include <ns3/mobility-helper.h>
+#include <ns3/net-device-container.h>
+#include <ns3/node-container.h>
+#include <ns3/point-to-point-epc-helper.h>
+#include <ns3/point-to-point-helper.h>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("LtePrimaryCellChangeTest");
+
+/*
+ * Test Suite
+ */
+
+LtePrimaryCellChangeTestSuite::LtePrimaryCellChangeTestSuite ()
+  : TestSuite ("lte-primary-cell-change", SYSTEM)
+{
+  // Test that handover from eNB to eNB with one carrier works within this framework.
+  AddTestCase (new LtePrimaryCellChangeTestCase ("ideal RRC, RngRun=1", true, 1, 1, 0, 1), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("real RRC, RngRun=1", false, 1, 1, 0, 1), TestCase::QUICK);
+
+  // Test that handover between first carriers of eNBs works.
+  AddTestCase (new LtePrimaryCellChangeTestCase ("ideal RRC, RngRun=1", true, 1, 2, 0, 2), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("real RRC, RngRun=1", false, 1, 2, 0, 2), TestCase::QUICK);
+
+  // Test that handover from second carrier of first eNB to first carrier of second eNB works.
+  AddTestCase (new LtePrimaryCellChangeTestCase ("ideal RRC, RngRun=1", true, 1, 2, 1, 2), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("real RRC, RngRun=1", false, 1, 2, 1, 2), TestCase::QUICK);
+
+  // Test that handover from first carrier of first eNB to first carrier of second eNB works.
+  AddTestCase (new LtePrimaryCellChangeTestCase ("ideal RRC, RngRun=1", true, 1, 2, 0, 3), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("real RRC, RngRun=1", false, 1, 2, 0, 3), TestCase::QUICK);
+
+  // Test that handover from second carrier of first eNB to second carrier of second eNB works.
+  AddTestCase (new LtePrimaryCellChangeTestCase ("ideal RRC, RngRun=1", true, 1, 2, 1, 3), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("real RRC, RngRun=1", false, 1, 2, 1, 3), TestCase::QUICK);
+
+  // Test intra-eNB inter-frequency handover.
+  AddTestCase (new LtePrimaryCellChangeTestCase ("ideal RRC, RngRun=1", true, 1, 2, 0, 1), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("real RRC, RngRun=1", false, 1, 2, 0, 1), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("ideal RRC, RngRun=1", true, 1, 2, 1, 0), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("real RRC, RngRun=1", false, 1, 2, 1, 0), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("ideal RRC, RngRun=1", true, 1, 4, 3, 1), TestCase::QUICK);
+  AddTestCase (new LtePrimaryCellChangeTestCase ("real RRC, RngRun=1", false, 1, 4, 3, 1), TestCase::QUICK);
+} // end of LtePrimaryCellChangeTestSuite::LtePrimaryCellChangeTestSuite ()
+
+static LtePrimaryCellChangeTestSuite g_ltePrimaryCellChangeTestSuite;
+
+/*
+ * Test Case
+ */
+
+LtePrimaryCellChangeTestCase::LtePrimaryCellChangeTestCase (
+  std::string name, bool isIdealRrc, int64_t rngRun,
+  uint8_t numberOfComponentCarriers, uint8_t sourceComponentCarrier, uint8_t targetComponentCarrier)
+  : TestCase (name),
+    m_isIdealRrc {isIdealRrc},
+    m_rngRun {rngRun},
+    m_numberOfComponentCarriers {numberOfComponentCarriers},
+    m_sourceComponentCarrier {sourceComponentCarrier},
+    m_targetComponentCarrier {targetComponentCarrier}
+{
+  NS_LOG_FUNCTION (this << GetName ());
+}
+
+
+LtePrimaryCellChangeTestCase::~LtePrimaryCellChangeTestCase ()
+{
+  NS_LOG_FUNCTION (this << GetName ());
+}
+
+void
+LtePrimaryCellChangeTestCase::DoRun ()
+{
+  NS_LOG_FUNCTION (this << GetName ());
+
+  Config::SetGlobal ("RngRun", UintegerValue (m_rngRun));
+
+  Config::SetDefault ("ns3::LteEnbNetDevice::DlEarfcn", UintegerValue (100));
+  Config::SetDefault ("ns3::LteEnbNetDevice::UlEarfcn", UintegerValue (100 + 18000));
+  Config::SetDefault ("ns3::LteEnbNetDevice::DlBandwidth", UintegerValue (25));
+  Config::SetDefault ("ns3::LteEnbNetDevice::UlBandwidth", UintegerValue (25));
+  Config::SetDefault ("ns3::LteUeNetDevice::DlEarfcn", UintegerValue (100));
+
+  // Create helpers.
+  auto lteHelper = CreateObject<LteHelper> ();
+  lteHelper->SetAttribute ("PathlossModel", TypeIdValue (ns3::FriisSpectrumPropagationLossModel::GetTypeId ()));
+  lteHelper->SetAttribute ("UseIdealRrc", BooleanValue (m_isIdealRrc));
+  lteHelper->SetAttribute ("NumberOfComponentCarriers", UintegerValue (m_numberOfComponentCarriers));
+
+  auto epcHelper = CreateObject<PointToPointEpcHelper> ();
+  lteHelper->SetEpcHelper (epcHelper);
+
+  // Create nodes.
+  NodeContainer enbNodes;
+  enbNodes.Create (2);
+  auto ueNode = CreateObject<Node> ();
+
+  MobilityHelper mobility;
+  mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
+  mobility.Install (enbNodes);
+  mobility.Install (ueNode);
+
+  // Physical layer.
+  auto enbDevs = lteHelper->InstallEnbDevice (enbNodes);
+  auto ueDev = DynamicCast<LteUeNetDevice> (lteHelper->InstallUeDevice (ueNode).Get (0));
+
+  auto sourceEnbDev = DynamicCast<LteEnbNetDevice> (enbDevs.Get (m_sourceComponentCarrier / m_numberOfComponentCarriers));
+  auto targetEnbDev = DynamicCast<LteEnbNetDevice> (enbDevs.Get (m_targetComponentCarrier / m_numberOfComponentCarriers));
+
+  // Network layer.
+  InternetStackHelper internet;
+  internet.Install (ueNode);
+  epcHelper->AssignUeIpv4Address (NetDeviceContainer (ueDev));
+
+  std::map<uint8_t, Ptr<ComponentCarrierUe>> ueCcMap = ueDev->GetCcMap ();
+  ueDev->SetDlEarfcn (ueCcMap.at (m_sourceComponentCarrier)->GetDlEarfcn ());
+
+  // Attach UE to specified component carrier
+  lteHelper->Attach (ueDev, sourceEnbDev, m_sourceComponentCarrier % m_numberOfComponentCarriers);
+
+  // Connect to trace sources in UEs
+  Config::Connect ("/NodeList/*/DeviceList/*/LteUeRrc/StateTransition",
+                   MakeCallback (&LtePrimaryCellChangeTestCase::StateTransitionCallback,
+                                 this));
+  Config::Connect ("/NodeList/*/DeviceList/*/LteUeRrc/ConnectionEstablished",
+                   MakeCallback (&LtePrimaryCellChangeTestCase::ConnectionEstablishedCallback,
+                                 this));
+
+  uint16_t targetCellId = targetEnbDev->GetCcMap ().at (m_targetComponentCarrier % m_numberOfComponentCarriers)->GetCellId ();
+
+  lteHelper->AddX2Interface (enbNodes);
+  lteHelper->HandoverRequest (Seconds (1.0), ueDev, sourceEnbDev, targetCellId);
+
+  // Run simulation.
+  Simulator::Stop (Seconds (2.0));
+  Simulator::Run ();
+
+  uint16_t expectedCellId = targetCellId;
+  uint16_t actualCellId = ueDev->GetRrc ()->GetCellId ();
+  NS_TEST_ASSERT_MSG_EQ (expectedCellId, actualCellId, "IMSI " << ueDev->GetImsi () << " has attached to an unexpected cell");
+
+  NS_TEST_ASSERT_MSG_EQ (m_lastState.at (ueDev->GetImsi ()),
+                         LteUeRrc::CONNECTED_NORMALLY,
+                         "UE " << ueDev->GetImsi ()
+                               << " is not at CONNECTED_NORMALLY state");
+
+  // Destroy simulator.
+  Simulator::Destroy ();
+} // end of void LtePrimaryCellChangeTestCase::DoRun ()
+
+
+void
+LtePrimaryCellChangeTestCase::StateTransitionCallback (
+  std::string context, uint64_t imsi, uint16_t cellId, uint16_t rnti,
+  LteUeRrc::State oldState, LteUeRrc::State newState)
+{
+  NS_LOG_FUNCTION (this << imsi << cellId << rnti << oldState << newState);
+  m_lastState[imsi] = newState;
+}
+
+void
+LtePrimaryCellChangeTestCase::ConnectionEstablishedCallback (
+  std::string context, uint64_t imsi, uint16_t cellId, uint16_t rnti)
+{
+  NS_LOG_FUNCTION (this << imsi << cellId << rnti);
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-test-primary-cell-change.h ns-3.36/src/lte/test/lte-test-primary-cell-change.h
--- ns-3.35/src/lte/test/lte-test-primary-cell-change.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/lte/test/lte-test-primary-cell-change.h	2022-04-30 18:23:58.062734600 -0700
@@ -0,0 +1,124 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Alexander Krotov
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alexander Krotov <krotov@iitp.ru>
+ *
+ */
+
+#ifndef LTE_TEST_PRIMARY_CELL_CHANGE_H
+#define LTE_TEST_PRIMARY_CELL_CHANGE_H
+
+#include <ns3/test.h>
+#include <ns3/nstime.h>
+#include <ns3/node-container.h>
+#include <ns3/vector.h>
+#include <ns3/lte-ue-rrc.h>
+#include <vector>
+
+using namespace ns3;
+
+/**
+ * \brief Test suite for executing the primary cell change test cases.
+ *
+ * \sa ns3::LtePrimaryCellChangeTestCase
+ */
+class LtePrimaryCellChangeTestSuite : public TestSuite
+{
+public:
+  LtePrimaryCellChangeTestSuite ();
+};
+
+
+
+
+/**
+ * \ingroup lte
+ *
+ * \brief Testing the handover procedure with multiple component carriers.
+ */
+class LtePrimaryCellChangeTestCase : public TestCase
+{
+public:
+  /**
+   * \brief Creates an instance of the initial cell selection test case.
+   * \param name name of this test
+   * \param isIdealRrc if true, simulation uses Ideal RRC protocol, otherwise
+   *                   simulation uses Real RRC protocol
+   * \param rngRun the number of run to be used by the random number generator
+   * \param numberOfComponentCarriers number of component carriers
+   * \param sourceComponentCarrier source component carrier
+   * \param targetComponentCarrier target component carrier
+   *
+   * If sourceComponentCarrier or targetComponentCarrier is greater than
+   * number of component carriers, it identifies component carrier on second eNB.
+   */
+  LtePrimaryCellChangeTestCase (std::string name, bool isIdealRrc, int64_t rngRun,
+                                uint8_t numberOfComponentCarriers,
+                                uint8_t sourceComponentCarrier,
+                                uint8_t targetComponentCarrier);
+
+  virtual ~LtePrimaryCellChangeTestCase ();
+
+private:
+  /**
+   * \brief Setup the simulation according to the configuration set by the
+   *        class constructor, run it, and verify the result.
+   */
+  virtual void DoRun ();
+
+  /**
+   * \brief State transition callback function
+   * \param context the context string
+   * \param imsi the IMSI
+   * \param cellId the cell ID
+   * \param rnti the RNTI
+   * \param oldState the old state
+   * \param newState the new state
+   */
+  void StateTransitionCallback (std::string context, uint64_t imsi,
+                                uint16_t cellId, uint16_t rnti,
+                                LteUeRrc::State oldState, LteUeRrc::State newState);
+  /**
+   * \brief Initial cell selection end ok callback function
+   * \param context the context string
+   * \param imsi the IMSI
+   * \param cellId the cell ID
+   */
+  void InitialPrimaryCellChangeEndOkCallback (std::string context, uint64_t imsi,
+                                          uint16_t cellId);
+  /**
+   * \brief Connection established callback function
+   * \param context the context string
+   * \param imsi the IMSI
+   * \param cellId the cell ID
+   * \param rnti the RNTI
+   */
+  void ConnectionEstablishedCallback (std::string context, uint64_t imsi,
+                                      uint16_t cellId, uint16_t rnti);
+
+  bool m_isIdealRrc; ///< whether the LTE is configured to use ideal RRC
+  int64_t m_rngRun; ///< rng run
+  uint8_t m_numberOfComponentCarriers; ///< number of component carriers
+  uint8_t m_sourceComponentCarrier; ///< source primary component carrier
+  uint8_t m_targetComponentCarrier; ///< target primary component carrier
+
+  /// The current UE RRC state.
+  std::map<uint64_t, LteUeRrc::State> m_lastState;
+
+}; // end of class LtePrimaryCellChangeTestCase
+
+#endif /* LTE_TEST_PRIMARY_CELL_CHANGE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-test-run-time.pl ns-3.36/src/lte/test/lte-test-run-time.pl
--- ns-3.35/src/lte/test/lte-test-run-time.pl	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/src/lte/test/lte-test-run-time.pl	2022-04-30 18:23:58.062734600 -0700
@@ -14,11 +14,11 @@
 my @simTime = (5, 10);
 
 # Configure and complite first the program to avoid counting compilation time as running time
-my $launch = "CXXFLAGS=\"-O3 -w\" ./waf -d optimized configure --enable-static --enable-examples --enable-modules=lte";
+my $launch = "CXXFLAGS=\"-O3 -w\" ./ns3 configure -d optimized --enable-static --enable-examples --enable-modules=lte";
 my $out;
 my $err;
 capture { system($launch ) } \$out, \$err;
-$launch = "./waf --run \'lena-profiling --simTime=0.1 --nUe=1 --nEnb=1 --nFloors=0\'";
+$launch = "./ns3 run \'lena-profiling --simTime=0.1 --nUe=1 --nEnb=1 --nFloors=0\'";
 capture { system($launch ) } \$out, \$err;
 
 foreach my $time (@simTime)
@@ -32,7 +32,7 @@
             my $timeStats = Statistics::Descriptive::Full->new();
             for ( my $iteration = 0 ; $iteration < $nIterations ; $iteration++ )
             {
-               $launch = "time -f \"real%E\" ./waf --run \'lena-profiling --simTime=$time --nUe=$ue --nEnb=$enb --nFloors=$floor\'";
+               $launch = "time -f \"real%E\" ./ns3 run \'lena-profiling --simTime=$time --nUe=$ue --nEnb=$enb --nFloors=$floor\'";
                print "$launch\n";
                capture { system($launch ) } \$out, \$err;
                $err =~ /real(.+):(.+)/;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-test-secondary-cell-handover.cc ns-3.36/src/lte/test/lte-test-secondary-cell-handover.cc
--- ns-3.35/src/lte/test/lte-test-secondary-cell-handover.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/lte/test/lte-test-secondary-cell-handover.cc	2022-04-30 18:23:58.062734600 -0700
@@ -0,0 +1,208 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Alexander Krotov
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alexander Krotov <krotov@iitp.ru>
+ *
+ */
+
+#include <ns3/friis-spectrum-propagation-loss.h>
+#include <ns3/log.h>
+#include <ns3/lte-enb-net-device.h>
+#include <ns3/lte-helper.h>
+#include <ns3/test.h>
+#include <ns3/point-to-point-epc-helper.h>
+#include <ns3/mobility-helper.h>
+#include <ns3/boolean.h>
+#include <ns3/double.h>
+#include <ns3/integer.h>
+#include <ns3/log.h>
+#include <ns3/simulator.h>
+#include <ns3/lte-ue-net-device.h>
+#include <ns3/internet-stack-helper.h>
+#include <ns3/lte-ue-rrc.h>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("LteSecondaryCellHandoverTest");
+
+/**
+ * \ingroup lte-test
+ * \ingroup tests
+ *
+ * \brief Test measurement-based handover to secondary cell.
+ */
+
+class LteSecondaryCellHandoverTestCase : public TestCase {
+public:
+  /**
+   * \brief Creates an instance of the measurement-based secondary cell handover test case.
+   * \param name name of the test case
+   * \param useIdealRrc if true, simulation uses Ideal RRC protocol, otherwise
+   *                    simulation uses Real RRC protocol
+   */
+
+  LteSecondaryCellHandoverTestCase (std::string name, bool useIdealRrc);
+
+  /**
+   * \brief Shutdown cellId by reducing its power to 1 dBm.
+   * \param cellId ID of the cell to shutdown
+   */
+  void ShutdownCell (uint32_t cellId);
+
+  /**
+   * \brief Callback method indicating start of UE handover
+   * \param imsi The IMSI
+   * \param sourceCellId The source cell ID
+   * \param rnti The RNTI
+   * \param targetCellId The target cell ID
+   */
+  void UeHandoverStartCallback (uint64_t imsi,
+                                uint16_t sourceCellId, uint16_t rnti,
+                                uint16_t targetCellId);
+
+
+
+private:
+  /**
+   * \brief Run a simulation.
+   */
+  virtual void DoRun ();
+
+  /**
+   * \brief Verify that handover has occurred during the simulation.
+   */
+  virtual void DoTeardown ();
+
+  bool m_useIdealRrc; ///< whether LTE is configured to use ideal RRC
+  uint8_t m_numberOfComponentCarriers; ///< Number of component carriers
+
+  Ptr<LteEnbNetDevice> m_sourceEnbDev; ///< Source eNB device
+
+  bool m_hasUeHandoverStarted; ///< true if UE started handover
+};
+
+LteSecondaryCellHandoverTestCase::LteSecondaryCellHandoverTestCase (std::string name, bool useIdealRrc)
+    : TestCase {name},
+      m_useIdealRrc {useIdealRrc},
+      m_numberOfComponentCarriers {2},
+      m_hasUeHandoverStarted {false}
+{
+}
+
+void
+LteSecondaryCellHandoverTestCase::ShutdownCell (uint32_t cellId)
+{
+  Ptr<LteEnbPhy> phy = m_sourceEnbDev->GetPhy (cellId - 1);
+  phy->SetTxPower (1);
+}
+
+void
+LteSecondaryCellHandoverTestCase::UeHandoverStartCallback (uint64_t imsi,
+                            uint16_t sourceCellId, uint16_t rnti,
+                            uint16_t targetCellId)
+{
+  NS_LOG_FUNCTION (this << imsi << sourceCellId << rnti << targetCellId);
+  m_hasUeHandoverStarted = true;
+}
+
+void
+LteSecondaryCellHandoverTestCase::DoRun ()
+{
+  NS_LOG_FUNCTION (this << GetName ());
+
+  Config::SetDefault ("ns3::LteEnbNetDevice::DlEarfcn", UintegerValue (100));
+  Config::SetDefault ("ns3::LteEnbNetDevice::UlEarfcn", UintegerValue (100 + 18000));
+  Config::SetDefault ("ns3::LteEnbNetDevice::DlBandwidth", UintegerValue (25));
+  Config::SetDefault ("ns3::LteEnbNetDevice::UlBandwidth", UintegerValue (25));
+  Config::SetDefault ("ns3::LteUeNetDevice::DlEarfcn", UintegerValue (100));
+
+  // Create helpers.
+  auto lteHelper = CreateObject<LteHelper> ();
+  lteHelper->SetAttribute ("PathlossModel", TypeIdValue (ns3::FriisSpectrumPropagationLossModel::GetTypeId ()));
+  lteHelper->SetAttribute ("UseIdealRrc", BooleanValue (m_useIdealRrc));
+  lteHelper->SetAttribute ("NumberOfComponentCarriers", UintegerValue (m_numberOfComponentCarriers));
+
+  // Configure handover algorithm.
+  lteHelper->SetHandoverAlgorithmType ("ns3::A3RsrpHandoverAlgorithm");
+  lteHelper->SetHandoverAlgorithmAttribute ("Hysteresis", DoubleValue (1.5));
+  lteHelper->SetHandoverAlgorithmAttribute ("TimeToTrigger", TimeValue (MilliSeconds (128)));
+
+  auto epcHelper = CreateObject<PointToPointEpcHelper> ();
+  lteHelper->SetEpcHelper (epcHelper);
+
+  // Create nodes.
+  auto enbNode = CreateObject<Node> ();
+  auto ueNode = CreateObject<Node> ();
+
+  // Setup node mobility.
+  MobilityHelper mobility;
+  mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
+  mobility.Install (enbNode);
+  mobility.Install (ueNode);
+
+  // Physical layer.
+  m_sourceEnbDev = DynamicCast<LteEnbNetDevice> (lteHelper->InstallEnbDevice (enbNode).Get (0));
+  auto ueDevs = lteHelper->InstallUeDevice (ueNode);
+  auto ueDev = DynamicCast<LteUeNetDevice> (ueDevs.Get (0));
+
+  // Network layer.
+  InternetStackHelper internet;
+  internet.Install (ueNode);
+  epcHelper->AssignUeIpv4Address (NetDeviceContainer (ueDev));
+
+  uint16_t sourceCellId = m_sourceEnbDev->GetCellId ();
+  Simulator::Schedule (Seconds (0.5), &LteSecondaryCellHandoverTestCase::ShutdownCell, this, sourceCellId);
+
+  // Setup traces.
+  ueDev->GetRrc ()->TraceConnectWithoutContext ("HandoverStart", MakeCallback (&LteSecondaryCellHandoverTestCase::UeHandoverStartCallback, this));
+
+  std::map<uint8_t, Ptr<ComponentCarrierUe>> ueCcMap = ueDev->GetCcMap ();
+  ueDev->SetDlEarfcn (ueCcMap.at (0)->GetDlEarfcn ());
+  lteHelper->Attach (ueDev, m_sourceEnbDev, 0);
+
+  // Run simulation.
+  Simulator::Stop (Seconds (1));
+  Simulator::Run ();
+  Simulator::Destroy ();
+}
+
+void
+LteSecondaryCellHandoverTestCase::DoTeardown ()
+{
+  NS_LOG_FUNCTION (this);
+  NS_TEST_ASSERT_MSG_EQ (m_hasUeHandoverStarted, true, "Handover did not occur");
+}
+
+/**
+ * \ingroup lte-test
+ * \ingroup tests
+ *
+ * \brief LTE measurement-based handover to secondary cell test suite.
+ */
+class LteSecondaryCellHandoverTestSuite : public TestSuite {
+public:
+    LteSecondaryCellHandoverTestSuite ();
+};
+
+LteSecondaryCellHandoverTestSuite::LteSecondaryCellHandoverTestSuite ()
+    : TestSuite {"lte-secondary-cell-handover", SYSTEM}
+{
+  AddTestCase (new LteSecondaryCellHandoverTestCase ("Ideal RRC", true), TestCase::QUICK);
+  AddTestCase (new LteSecondaryCellHandoverTestCase ("Real RRC", false), TestCase::QUICK);
+}
+
+static LteSecondaryCellHandoverTestSuite g_lteSecondaryCellHandoverTestSuiteInstance;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/lte/test/lte-test-secondary-cell-selection.cc ns-3.36/src/lte/test/lte-test-secondary-cell-selection.cc
--- ns-3.35/src/lte/test/lte-test-secondary-cell-selection.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/src/lte/test/lte-test-secondary-cell-selection.cc	2022-04-30 18:23:58.062734600 -0700
@@ -0,0 +1,182 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2017 Alexander Krotov
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Alexander Krotov <krotov@iitp.ru>
+ *
+ */
+
+#include "lte-test-secondary-cell-selection.h"
+
+#include <ns3/boolean.h>
+#include <ns3/double.h>
+#include <ns3/integer.h>
+#include <ns3/log.h>
+#include <ns3/simulator.h>
+
+#include <ns3/internet-stack-helper.h>
+#include <ns3/ipv4-address-helper.h>
+#include <ns3/ipv4-interface-container.h>
+#include <ns3/friis-spectrum-propagation-loss.h>
+#include <ns3/ipv4-static-routing-helper.h>
+#include <ns3/lte-enb-net-device.h>
+#include <ns3/lte-helper.h>
+#include <ns3/lte-ue-net-device.h>
+#include <ns3/lte-ue-rrc.h>
+#include <ns3/mobility-helper.h>
+#include <ns3/net-device-container.h>
+#include <ns3/node-container.h>
+#include <ns3/point-to-point-epc-helper.h>
+#include <ns3/point-to-point-helper.h>
+
+using namespace ns3;
+
+NS_LOG_COMPONENT_DEFINE ("LteSecondaryCellSelectionTest");
+
+/*
+ * Test Suite
+ */
+
+LteSecondaryCellSelectionTestSuite::LteSecondaryCellSelectionTestSuite ()
+  : TestSuite ("lte-secondary-cell-selection", SYSTEM)
+{
+  // REAL RRC PROTOCOL, either 2 or 4 UEs connecting to 2 or 4 component carriers
+
+  AddTestCase (new LteSecondaryCellSelectionTestCase ("EPC, real RRC, RngRun=1", false, 1U, 2), TestCase::QUICK);
+  AddTestCase (new LteSecondaryCellSelectionTestCase ("EPC, real RRC, RngRun=1", false, 1U, 4), TestCase::QUICK);
+
+  // IDEAL RRC PROTOCOL, either 2 or 4 UEs connecting to 2 or 4 component carriers
+
+  AddTestCase (new LteSecondaryCellSelectionTestCase ("EPC, ideal RRC, RngRun=1", true, 1U, 2), TestCase::QUICK);
+  AddTestCase (new LteSecondaryCellSelectionTestCase ("EPC, ideal RRC, RngRun=1", true, 1U, 4), TestCase::QUICK);
+
+} // end of LteSecondaryCellSelectionTestSuite::LteSecondaryCellSelectionTestSuite ()
+
+static LteSecondaryCellSelectionTestSuite g_lteSecondaryCellSelectionTestSuite;
+
+/*
+ * Test Case
+ */
+
+LteSecondaryCellSelectionTestCase::LteSecondaryCellSelectionTestCase (
+  std::string name, bool isIdealRrc, uint64_t rngRun, uint8_t numberOfComponentCarriers)
+  : TestCase (name),
+    m_isIdealRrc (isIdealRrc),
+    m_rngRun (rngRun),
+    m_numberOfComponentCarriers (numberOfComponentCarriers)
+{
+  NS_LOG_FUNCTION (this << GetName ());
+}
+
+
+LteSecondaryCellSelectionTestCase::~LteSecondaryCellSelectionTestCase ()
+{
+  NS_LOG_FUNCTION (this << GetName ());
+}
+
+void
+LteSecondaryCellSelectionTestCase::DoRun ()
+{
+  NS_LOG_FUNCTION (this << GetName ());
+
+  Config::SetGlobal ("RngRun", UintegerValue (m_rngRun));
+
+  // Create helpers.
+  auto lteHelper = CreateObject<LteHelper> ();
+  lteHelper->SetAttribute ("PathlossModel", TypeIdValue (ns3::FriisSpectrumPropagationLossModel::GetTypeId ()));
+  lteHelper->SetAttribute ("UseIdealRrc", BooleanValue (m_isIdealRrc));
+  lteHelper->SetAttribute ("NumberOfComponentCarriers", UintegerValue (m_numberOfComponentCarriers));
+
+  auto epcHelper = CreateObject<PointToPointEpcHelper> ();
+  lteHelper->SetEpcHelper (epcHelper);
+
+  // Create nodes.
+  auto enbNode = CreateObject<Node> ();
+  NodeContainer ueNodes;
+  ueNodes.Create (m_numberOfComponentCarriers);
+
+  MobilityHelper mobility;
+  mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
+  mobility.Install (enbNode);
+  mobility.Install (ueNodes);
+
+  // Physical layer.
+  auto enbDev = DynamicCast<LteEnbNetDevice> (lteHelper->InstallEnbDevice (enbNode).Get (0));
+  auto ueDevs = lteHelper->InstallUeDevice (ueNodes);
+
+  // Network layer.
+  InternetStackHelper internet;
+  internet.Install (ueNodes);
+  epcHelper->AssignUeIpv4Address (ueDevs);
+
+  auto ueDev = DynamicCast<LteUeNetDevice> (ueDevs.Get (0));
+  std::map< uint8_t, Ptr<ComponentCarrierUe> > ueCcMap = ueDev->GetCcMap ();
+  for (auto it: ueCcMap)
+    {
+      NS_LOG_DEBUG ("Assign DL EARFCN " << it.second->GetDlEarfcn() << " to UE " << ueDevs.Get (it.first)->GetNode ()->GetId ());
+      DynamicCast<LteUeNetDevice> (ueDevs.Get (it.first))->SetDlEarfcn (it.second->GetDlEarfcn());
+    }
+
+  // Enable Idle mode cell selection.
+  lteHelper->Attach (ueDevs);
+
+  // Connect to trace sources in UEs
+  Config::Connect ("/NodeList/*/DeviceList/*/LteUeRrc/StateTransition",
+                   MakeCallback (&LteSecondaryCellSelectionTestCase::StateTransitionCallback,
+                                 this));
+  Config::Connect ("/NodeList/*/DeviceList/*/LteUeRrc/ConnectionEstablished",
+                   MakeCallback (&LteSecondaryCellSelectionTestCase::ConnectionEstablishedCallback,
+                                 this));
+
+  // Run simulation.
+  Simulator::Stop (Seconds (2.0));
+  Simulator::Run ();
+
+  for (auto &it: enbDev->GetCcMap ())
+    {
+      ueDev = DynamicCast<LteUeNetDevice> (ueDevs.Get (it.first));
+      uint16_t expectedCellId = it.second->GetCellId ();
+      uint16_t actualCellId = ueDev->GetRrc ()->GetCellId ();
+      NS_LOG_DEBUG ("RNTI " << ueDev->GetRrc ()->GetRnti () << " attached to cell ID: " << actualCellId);
+      NS_TEST_ASSERT_MSG_EQ (expectedCellId, actualCellId, "IMSI " << ueDev->GetImsi () << " has attached to an unexpected cell");
+
+      NS_TEST_ASSERT_MSG_EQ (m_lastState.at (ueDev->GetImsi ()),
+                             LteUeRrc::CONNECTED_NORMALLY,
+                             "UE " << ueDev->GetImsi ()
+                                   << " is not at CONNECTED_NORMALLY state");
+    }
+
+  // Destroy simulator.
+  Simulator::Destroy ();
+} // end of void LteSecondaryCellSelectionTestCase::DoRun ()
+
+
+void
+LteSecondaryCellSelectionTestCase::StateTransitionCallback (
+  std::string context, uint64_t imsi, uint16_t cellId, uint16_t rnti,
+  LteUeRrc::State oldState, LteUeRrc::State newState)
+{
+  NS_LOG_FUNCTION (this << imsi << cellId << rnti << LteUeRrc::ToString (oldState) << LteUeRrc::ToString (newState));
+  m_lastState[imsi] = newState;
+}
+
+
+void
+LteSecondaryCellSelectionTestCase::ConnectionEstablishedCallback (
+  std::string context, uint64_t imsi, uint16_t cellId, uint16_t rnti)
+{
+  NS_LOG_FUNCTION (this << imsi << cellId << rnti);
+}
